/*
************************************************************************************
*                                                                                  * 
*  Copyright (c) 2004, Filipe Maia                                                 *
*   All rights reserved.                                                           *
*                                                                                  *
*  Redistribution and use in source and binary forms, with or without              *
*  modification, are permitted provided that the following conditions are met:     *
*    -Redistributions of source code must retain the above copyright notice, this  *
*     list of conditions and the following disclaimer.                             *
*    -Redistributions in binary form must reproduce the above copyright notice,    *
*     this list of conditions and the following disclaimer in the documentation    *
*     and/or other materials provided with the distribution.                       *
*    -The names of its contributors may not be used to endorse or promote          *
*     products derived from this software without specific prior written           *
*     permission.                                                                  *
*                                                                                  *
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"     *
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE       *
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE  *
*  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE     *
*  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL      *
*  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR      *
*  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER      *
*  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,   *
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   *
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.            *
*                                                                                  *
************************************************************************************
*/
#ifndef _INIT_H_
#define _INIT_H_

extern BitBoard n_bit_mask[65];

extern BitBoard mask[64];
extern BitBoard mask_rank[8];
extern BitBoard mask_file[8];
extern Position game;

extern BitBoard path[64][64];
extern short directions[64][64];
extern BitBoard beam[64][64];

extern BitBoard en_passant_mask[64];

extern BitBoard mask_qr_trapped_b[3];
extern BitBoard mask_kr_trapped_b[3];
extern BitBoard mask_qr_trapped_w[3];
extern BitBoard mask_kr_trapped_w[3];

extern BitBoard b_pawn_attacks[64];
extern BitBoard w_pawn_attacks[64];
extern BitBoard dark_squares;
extern BitBoard light_squares;

extern BitBoard mask_WBT;
extern BitBoard mask_BBT;

extern BitBoard mask_abc;
extern BitBoard mask_fgh;
extern BitBoard mask_abcd;
extern BitBoard mask_efgh;

extern  signed char kval_bn[64];
extern  signed char kval_bk[64];
extern  signed char kval_bq[64];


void init_game();
void init_const_boards();
void init_masks();
void init_path();
void init_directions();
void init_beam();

#endif
