/*
MIT License

Copyright (c) 2000 Adrien M. Regimbald, 2004 Filipe Maia

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/


#ifndef _SCORE_H_
#define _SCORE_H_

#define PAWN_VALUE 100
#define KNIGHT_VALUE 300
#define BISHOP_VALUE 300
#define ROOK_VALUE 500
#define QUEEN_VALUE 900
#define KING_VALUE 40000
#define MATE 32767
#define DRAW 0

#define TotalWhitePieces (game.white_material-game.white_pawns*PAWN_VALUE-KING_VALUE)
#define TotalBlackPieces (game.black_material-game.black_pawns*PAWN_VALUE-KING_VALUE)


extern int piece_value[13];
extern int start_piece_count;

int score(int alpha, int beta);
int end_score (int alpha,int beta);
int mid_score (int alpha,int beta);
int opn_score (int alpha,int beta);
#endif
