/*
************************************************************************************
*                                                                                  * 
*  Copyright (c) 2004, Filipe Maia                                                 *
*   All rights reserved.                                                           *
*                                                                                  *
*  Redistribution and use in source and binary forms, with or without              *
*  modification, are permitted provided that the following conditions are met:     *
*    -Redistributions of source code must retain the above copyright notice, this  *
*     list of conditions and the following disclaimer.                             *
*    -Redistributions in binary form must reproduce the above copyright notice,    *
*     this list of conditions and the following disclaimer in the documentation    *
*     and/or other materials provided with the distribution.                       *
*    -The names of its contributors may not be used to endorse or promote          *
*     products derived from this software without specific prior written           *
*     permission.                                                                  *
*                                                                                  *
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"     *
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE       *
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE  *
*  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE     *
*  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL      *
*  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR      *
*  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER      *
*  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,   *
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   *
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.            *
*                                                                                  *
************************************************************************************
*/

#ifndef _SEARCH_H_
#define _SEARCH_H_


#define NULL_PRUNE_R 2
#define TIME_PER_MOVE 3
#define REDUCED_TIME_PER_MOVE 1

#define PLY 60
#define NMS_MATE_EXTENSION 45
#define CHECK_EXTENSION 45
#define PROMOTE_EXTENSION 45
#define RECAPTURE_EXTENSION 45
#define SINGLE_REPLY_EXTENSION 60

/* prevent extensions which are very deep
 a is the extension b is the current depth (ply)*/
#define limit_extensions(a,b) ((cur_depth*2>b)?a:a/2)

typedef struct{
  int s;
  Move m;
} An_Move;

typedef struct{
  int cmove;              /* Number of moves in the line.*/
  Move argmove[100];  /* The line.*/
}Line;

extern long total_nodes;
extern long quies_nodes;
extern long negamax_nodes;
extern volatile char stop_search;
extern int mate_in;

An_Move search();

void end_search();
void check_time();

#endif
