/*
************************************************************************************
*                                                                                  * 
*  Copyright (c) 2004, Filipe Maia                                                 *
*   All rights reserved.                                                           *
*                                                                                  *
*  Redistribution and use in source and binary forms, with or without              *
*  modification, are permitted provided that the following conditions are met:     *
*    -Redistributions of source code must retain the above copyright notice, this  *
*     list of conditions and the following disclaimer.                             *
*    -Redistributions in binary form must reproduce the above copyright notice,    *
*     this list of conditions and the following disclaimer in the documentation    *
*     and/or other materials provided with the distribution.                       *
*    -The names of its contributors may not be used to endorse or promote          *
*     products derived from this software without specific prior written           *
*     permission.                                                                  *
*                                                                                  *
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"     *
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE       *
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE  *
*  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE     *
*  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL      *
*  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR      *
*  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER      *
*  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,   *
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   *
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.            *
*                                                                                  *
************************************************************************************
*/

#ifndef _VALIDATE_H_
#define _VALIDATE_H_

int validate(Move m);
void init_val_table();

extern unsigned char val_table[13][64][64];

#define PAWN_ODD_CAP_UP 1
#define PAWN_ODD_CAP_DOWN 2
#define PAWN_EVEN_CAP_UP 3
#define PAWN_EVEN_CAP_DOWN 4
#define PAWN_NORMAL_UP 5
#define PAWN_NORMAL_DOWN 6
#define PAWN_DOUBLE_UP 7
#define PAWN_DOUBLE_DOWN 8
#define RANK_RIGHT 9
#define RANK_LEFT 10
#define FILE_UP 11
#define FILE_DOWN 12
#define ODD_UP 13
#define ODD_DOWN 14
#define EVEN_UP 15
#define EVEN_DOWN 16
#define POSSIBLY_CASTLE 17
#define VALID_MOVE 18
#define INVALID_MOVE 19
#define KNIGHT_MOVE 20

#endif
